package app.mrbool.com.customlistviewapp;

import java.util.ArrayList;
import java.util.List;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.TextView;

import com.android.volley.toolbox.ImageLoader;
import com.android.volley.toolbox.NetworkImageView;

/**
 * Created by Diogo on 29/06/2016.
 */
public class CustomListAdapter extends BaseAdapter {

    private Activity activity;
    private List<Product> Products = new ArrayList<Product>();

    private LayoutInflater inflater;

    ImageLoader imageLoader = AppController.getInstance().getImageLoader();

    private ProductListAdapterListener listener;

    public CustomListAdapter(Activity activity, List<Product> Products, ProductListAdapterListener listener) {
        this.activity = activity;
        this.Products = Products;
        this.listener = listener;
    }

    @Override
    public int getCount() {
        return Products.size();
    }

    @Override
    public Object getItem(int position) {
        return Products.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @SuppressLint("InflateParams")
    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        if (inflater == null) {
            inflater = (LayoutInflater) activity.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        }

        if (convertView == null) {
            convertView = inflater.inflate(R.layout.row_layout, null);
        }

        if (imageLoader == null) {
            imageLoader = AppController.getInstance().getImageLoader();
        }

        NetworkImageView imageProd = (NetworkImageView) convertView.findViewById(R.id.imgProduct);
        TextView txtTitle = (TextView) convertView.findViewById(R.id.txtTitle);
        TextView txtDescription = (TextView) convertView.findViewById(R.id.txtDescription);

        final Product prod = Products.get(position);

        imageProd.setImageUrl(prod.getUrlImg(), imageLoader);

        txtTitle.setText(prod.getTitle());
        txtDescription.setText(prod.getDescription());

        Button btnAddToCart = (Button) convertView.findViewById(R.id.btnAddCart);

        btnAddToCart.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                listener.onAddCartPressed(prod);
            }
        });

        return convertView;
    }

    public interface ProductListAdapterListener {
        public void onAddCartPressed(Product Product);
    }

}